--main.lua

function love.load()

	g = love.graphics
	k = love.keyboard

	hero = {}
		hero.w = 128
		hero.h = 128
		hero.x = 300
		hero.y = 300
		hero.xv = 0
		hero.yv = 0
		hero.sprite = g.newImage("assets/hero.png")

	slash = {}
		slash.speed = 250
		slash.sprite = g.newImage("assets/slash.png")

end

function love.update(dt)

	hero.x = hero.x + hero.xv
	hero.y = hero.y + hero.yv

	if k.isDown "a" then
		hero.xv = -5
	elseif k.isDown "d" then
		hero.xv = 5
	else
		hero.xv = 0
	end

	if k.isDown "w" then
		hero.yv = -5
	elseif k.isDown "s" then
		hero.yv = 5
	else
		hero.yv = 0
	end

	for i,v in ipairs(slash) do
        v["x"] = v["x"] + (v["dx"] * dt)
        v["y"] = v["y"] + (v["dy"] * dt)
    end


end

function love.draw()

	local x1 = hero.x
	local y1 = hero.y
	local x2 = love.mouse.getX()
	local y2 = love.mouse.getY()

	local angle = math.deg(math.atan2(y2 - y1, x2 - x1)) 

	love.graphics.setColor(255, 255, 255)

		g.draw(hero.sprite, hero.x, hero.y)

	love.graphics.setColor(128, 128, 128)
   	
    	for i,v in ipairs(slash) do
        	g.draw(slash.sprite, v["x"], v["y"], angle)
   		end

end

function love.mousepressed(x, y, button)
 
  if button == "l" then
        
        local startx = hero.x
        local starty = hero.y
        local mousex = x
        local mousey = y
        
        local angle = math.atan2((mousey - starty), (mousex - startx))
        
        local slashdx = slash.speed * math.cos(angle)
        local slashdy = slash.speed * math.sin(angle)
        
        table.insert(slash, {x = startx, y = starty, dx = slashdx, dy = slashdy})
    
    end

end